<?php
// test main page
$page['header'] = LBL_TEST;
$page['content'] = "";

$grouper['stem'] = 'test:performance';
$control = $_POST['control'];
if (!$iterations = $_POST['iterations']) $iterations = 10;


if (!$control) {
  $page['content'] .= "This page does some basic Grouper performance and functionality testing.<br>\n";
  $page['content'] .= "Let the script end completely, as it creates and afterwards deletes many (test)groups!<br><br>\n";
  $page['content'] .= "<form method='post'>\n";
  $page['content'] .= "Number of iterations the script should perform:\n";
  $page['content'] .= "<input type=text name='iterations' size='5' value='" . $iterations . "'><br><br>\n";
  $page['content'] .= "<input type='submit' name='control' value='Start'>\n";
  $page['content'] .= "</form>\n";

} else {
  set_time_limit(0); // Disable script timeouts!

  $page['content'] .= "Iterations: $iterations<br><br>\n";

  $t1 = microtime(true);
  $gr = new_grouper();
  $t2 = microtime(true);

  if (!$gr->isConnected()) {
    $page['errors'][] = ERROR_GROUPER_CONNECT;
    return;
  } else {
    $delta = microdelta($t1, $t2);
    $page['content'] .= "Connection with grouper server successful: " .$delta . " seconds.<br><br>\n";
  }

  $t1 = microtime(true);
  while (count($new_groups) < $iterations) {
    $new_name = uniqid();
    $result = $gr->addGroup($new_name, $new_name);
    $new_groups[] = $result['id'];
  }
  $t2 = microtime(true);
  $delta = microdelta($t1, $t2);
  $page['content'] .= "Created $iterations groups: " .$delta . " seconds = " . round($delta/$iterations, 5) . " each<br>\n";

  foreach ($new_groups as $group_id) {
    $gr->addMember($group_id, $uuid, $uuid);
  }
  $t2 = microtime(true);
  $delta = microdelta($t1, $t2);
  $page['content'] .= "Added member to group for $iterations groups: " .$delta . " seconds = " . round($delta/$iterations, 5) . " each<br>\n";

  $t1 = microtime(true);
  foreach ($new_groups as $group_id) {
    $gr->setPrivilege($group_id, $uuid, 'admin', TRUE);
    $gr->setPrivilege($group_id, $uuid, 'update', TRUE);
    $gr->setPrivilege($group_id, $uuid, 'optout', TRUE);
  }
  $t2 = microtime(true);
  $delta = microdelta($t1, $t2);
  $page['content'] .= "Added admin Privileges (3ws calls) for $iterations groups: " .$delta . " seconds = " . round($delta/$iterations, 5) . " each<br>\n";


  $t1 = microtime(true);
  foreach ($new_groups as $group_id) {
    $gr->getSubjectGroupPrivileges($uuid, $group_id);
  }
  $t2 = microtime(true);
  $delta = microdelta($t1, $t2);
  $page['content'] .= "Asked Subject Privileges for $iterations groups: " .$delta . " seconds = " . round($delta/$iterations, 5) . " each<br>\n";


  $t1 = microtime(true);
  foreach ($new_groups as $group_id) {
    $gr->deleteGroup($group_id);
  }
  $t2 = microtime(true);
  $delta = microdelta($t1, $t2);
  $page['content'] .= "Deleted $iterations groups: " .$delta . " seconds = " . round($delta/$iterations, 5) . " each<br>\n";

  $page['content'] .= "<br><br>Testgroups that were created and should be deleted:<br>\n";
  foreach ($new_groups as $group_id) {
    $page['content'] .= "$group_id<br>\n";
  }


}
?>